unit UnidadCasa;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, DBGrids, Buttons, DBTables, Grids, ExtCtrls,
  ComCtrls, ToolWin, Qrctrls, QuickRpt, variants;

type
  TFormCasas = class(TForm)
    Navegador: TDBNavigator;
    Panel1: TPanel;
    TTabla: TTable;
    DCasas: TDataSource;
    Tabla: TDBGrid;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel2: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    BAnadir: TBitBtn;
    BEliminar: TBitBtn;
    N: TStaticText;
    LImpresion: TQuickRep;
    QRBand1: TQRBand;
    QRSubDetail1: TQRSubDetail;
    QRDBText10: TQRDBText;
    QRDBText9: TQRDBText;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRBand2: TQRBand;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRBand3: TQRBand;
    QRSysData2: TQRSysData;
    QRSysData4: TQRSysData;
    LEmpresa: TQRLabel;
    QRBand4: TQRBand;
    LTitulo: TQRSysData;
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TablaEnter(Sender: TObject);
    procedure TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure BitBtn1Click2(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BAnadirClick(Sender: TObject);
    procedure BEliminarClick(Sender: TObject);
    procedure TTablaAfterScroll(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormCasas: TFormCasas;

implementation

uses UnidadMenuPrincipal, UnidadDatos;

{$R *.DFM}


procedure TFormCasas.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.SetFocus;
  tabla.selectedindex:=1;
end;

procedure TFormCasas.TablaEnter(Sender: TObject);
begin
  dcasas.dataset.FieldByName('Telefono').editmask:='0000000009;1;_';
end;


procedure TFormCasas.TTablaPostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('La casa introducida ya existe, cmbiela y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;

procedure TFormCasas.BitBtn1Click2(Sender: TObject);
begin
  close;
end;

procedure TFormCasas.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption :=  formmenuprincipal.vtnombreempresa + ' [' + datetostr (formmenuprincipal.vtinicioempresa) +
        ' - ' + datetostr (formmenuprincipal.vtfinempresa) + ']';
  limpresion.ReportTitle:='LISTADO CASAS COMERCIALES';
  limpresion.Preview;
end;


procedure TFormCasas.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Nombre';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormCasas.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;

procedure TFormCasas.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
  end;  
end;

procedure TFormCasas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (dcasas.dataset.state=dsinsert) or (dcasas.dataset.state=dsedit) then
    dcasas.dataset.post;
  screen.cursor:=crdefault;
  action := cafree;
end;

procedure TFormCasas.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.open;
  n.caption:=inttostr(dcasas.dataset.recno) + ' de ' + inttostr(dcasas.DataSet.recordcount);
  if formmenuprincipal.vtmostrarbbventanas=1 then
    cb.visible:=true
  else
    cb.visible:=false;
  if formmenuprincipal.vtflat=1 then
  begin
    navegador.flat:=true;
    bb.flat:=true;
  end
  else
  begin
    navegador.flat:=false;
    bb.flat:=false;
  end;
  screen.cursor:=crdefault;
end;

procedure TFormCasas.BAnadirClick(Sender: TObject);
begin
  dcasas.DataSet.Insert;
end;



procedure TFormCasas.BEliminarClick(Sender: TObject);
var
  nombre: string;
begin
  if dcasas.dataset.recordcount=0 then
  begin
    messagedlg ('No hay casas para eliminar.',mtinformation,[mbok],0);
    exit;
  end;
  if not (dcasas.dataset.fieldbyname('Nombre').value=Null) then
    Nombre:=dcasas.dataset.fieldbyname('Nombre').value
  else
    nombre:='';
  datos.dproductos.dataset.open;
  if datos.Dproductos.DataSet.Locate('Casa',dcasas.DataSet.fieldbyname('ID').value,[]) then
  begin
    messagedlg('La casa [' + nombre + '] No se puede eliminar ya que existe en productos.',mtinformation,[mbok],0);
    exit;
  end;
  if messagedlg('Est seguro que desea ELIMINAR la finca [' + Nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
    dcasas.dataset.delete;
end;

procedure TFormCasas.TTablaAfterScroll(DataSet: TDataSet);
begin
  n.caption:=inttostr(dcasas.dataset.recno) + ' de ' + inttostr(dcasas.DataSet.recordcount);
end;

end.
