unit UnidadCopiaSeguridad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Outline, DirOutln, FileCtrl, Buttons, Menus;

type
  TFormCopiaSeguridad = class(TForm)
    GroupBox1: TGroupBox;
    Unidad: TDriveComboBox;
    StaticText1: TStaticText;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Eliminarcarpeta1: TMenuItem;
    Carpeta: TDirectoryListBox;
    P: TStaticText;
    Ficheros: TFileListBox;
    StaticText2: TStaticText;
    NFicheros: TStaticText;
    N2: TMenuItem;
    Hacercopiadeseguridad1: TMenuItem;
    BCopia: TSpeedButton;
    BCerrar: TSpeedButton;
    procedure BCerrarClick(Sender: TObject);
    procedure UnidadChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Eliminarcarpeta1Click(Sender: TObject);
    procedure BCopiaClick(Sender: TObject);
    procedure CarpetaChange(Sender: TObject);
    procedure FicherosChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCopiaSeguridad: TFormCopiaSeguridad;

implementation

{$R *.DFM}

procedure TFormCopiaSeguridad.BCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TFormCopiaSeguridad.UnidadChange(Sender: TObject);
{var
  Disponible, Total, Libre: int64;
  libret: string;
  libree: integer;}
begin
  carpeta.drive:=unidad.Drive;
  carpeta.Update;
{  getdiskfreespaceex(pchar(unidad.Drive),Disponible,Total,@Libre);
  txtespaciolibre.text:=inttostr(Libre) + ' Bytes';
  txttamanototal.text:=inttostr(Total) + ' Bytes';}
end;

procedure TFormCopiaSeguridad.N1Click(Sender: TObject);
var
  Nombre: string;
  Fecha: TDateTime;
  Ano, Mes, Dia: Word;
begin
  fecha:= date;
  DecodeDate(fecha, ano, mes, dia);
  nombre:='csABONADOS_' + inttostr(dia) + '_' + inttostr(mes) + '_' + inttostr(ano);
  if inputquery('Nueva carpeta...','Introduzca el nombre de la carpeta.',Nombre) then
  begin
    try
      mkdir (nombre);
    except on exception do
      messagedlg('No se ha podido aadir la nueva carpeta.',mterror,[mbok],0);
    end;
    carpeta.Update;
  end;
end;

procedure TFormCopiaSeguridad.Eliminarcarpeta1Click(Sender: TObject);
var
  directorio: string;
begin
  directorio:=carpeta.getitempath(carpeta.itemindex);
  carpeta.directory:=carpeta.getitempath(carpeta.itemindex-1);
  try
    rmdir (directorio);
  except on exception do
    messagedlg('No se ha podido eliminar la carpeta. Recuerde que debe estar vaca para poder eliminarla.',mterror,[mbok],0);
  end;
  carpeta.Update;
  ficheros.update;
end;

procedure TFormCopiaSeguridad.BCopiaClick(Sender: TObject);
var
  rutacopia: string;
  rutaprograma: string;
  rutaficheroprograma: string;
  nombre: TSearchRec;
  nombre2: tsearchrec;
  Atributos: Integer;
  rutacopiafichero: string;
begin
  atributos:=faAnyFile;
  if messagedlg('Atencin: se va a eliminar el contenido de la carpeta seleccionada. Pulse "Cancel" para cancelar el proceso.',mtconfirmation,[mbok,mbcancel],0)=mrok then
  begin
    ficheros.Clear;
    rutacopia:=carpeta.getitempath(carpeta.itemindex) + '\';
    Rutaprograma := extractfilepath(application.exename) + 'Tablas\';
    if FindFirst(rutacopia+ '*.*', Atributos, Nombre) = 0 then
    begin
//      if (nombre.name<>'.') and (nombre.name<>'..') then
      p.caption:='Realizando copia de seguridad, eliminando fichero ' + nombre.name + '...';
      p.refresh;
      try
        deletefile(nombre.name);
      except
      end;                                                         
      while   FindNext(nombre)=0 do
      begin
        p.caption:='Realizando copia de seguridad, eliminando fichero ' + nombre.name + '...';
        p.refresh;
        try
          deletefile(nombre.name);
        except
        end;
      end;
    end;
    FindClose(nombre);
    if FindFirst(rutaprograma+'*.*', Atributos, Nombre2) = 0 then
    begin
      //if (nombre2.name<>'.') and (nombre2.name<>'..') then
      p.caption:='Realizando copia de seguridad, copiando fichero ' + nombre2.name + '...';
      p.refresh;
      rutacopiafichero:=rutacopia + nombre2.name;
      rutaficheroprograma:=rutaprograma + nombre2.name;
      try
        copyfile(pchar(rutaficheroprograma),pchar(rutacopiafichero),true);
      except
        messagedlg ('No se ha podido realizar la copia correctamente. Intntelo en otro momento.',mterror,[mbok],0);
        ficheros.Update;
        ficheros.Refresh;
        exit;
      end;
      while findnext(nombre2)=0 do
      begin
        p.caption:='Realizando copia de seguridad, copiando fichero ' + nombre2.name + '...';
        p.refresh;
        rutacopiafichero:=rutacopia + nombre2.name;
        rutaficheroprograma:=rutaprograma + nombre2.name;
        try
          copyfile(pchar(rutaficheroprograma),pchar(rutacopiafichero),true);
        except
          messagedlg ('No se ha podido realizar la copia correctamente. Intntelo en otro momento.',mterror,[mbok],0);
          p.caption:='Copia no realizada.';
          p.Refresh;
          ficheros.Update;
          ficheros.Refresh;
          exit;
        end;
      end;
      FindClose(nombre2);
    end;
  end;
  p.caption:='Copia de seguridad realizada con xito.';
  p.Refresh;
  ficheros.Update;
  ficheros.Refresh;
end;

procedure TFormCopiaSeguridad.CarpetaChange(Sender: TObject);
begin
  ficheros.drive:=unidad.Drive;
  ficheros.Directory:=carpeta.Directory;
  ficheros.Update;
end;

procedure TFormCopiaSeguridad.FicherosChange(Sender: TObject);
begin
  nficheros.caption:='N de ficheros: ' + inttostr(ficheros.items.Count);
  nficheros.Refresh;
end;

procedure TFormCopiaSeguridad.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:=cafree;
end;

end.
