unit UnidadTotalesProductos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Buttons, Mask, ExtCtrls, Db, DBTables, Grids, DBGrids,
  Qrctrls, QuickRpt;

type
  TFormTotalesProductos = class(TForm)
    GroupBox1: TGroupBox;
    TxtFinca: TDBLookupComboBox;
    Panel5: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    TxtDesde: TMaskEdit;
    TxtHasta: TMaskEdit;
    Label5: TLabel;
    BitBtn2: TBitBtn;
    TxtPlan: TComboBox;
    Label8: TLabel;
    C: TQuery;
    DBD: TDataSource;
    Tabla: TDBGrid;
    DFinca: TDataSource;
    TFinca: TTable;
    Splitter1: TSplitter;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    LImpresion: TQuickRep;
    QRBand2: TQRBand;
    QRLabel3: TQRLabel;
    QRLabel10: TQRLabel;
    QRSubDetail1: TQRSubDetail;
    QRDBText5: TQRDBText;
    QRDBText9: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel5: TQRLabel;
    QRLabel9: TQRLabel;
    QRBand4: TQRBand;
    QRSysData1: TQRSysData;
    QRSysData4: TQRSysData;
    LEmpresa: TQRLabel;
    QRBand5: TQRBand;
    QRSysData5: TQRSysData;
    LFinca: TQRLabel;
    LPeriodo: TQRLabel;
    QRDBText1: TQRDBText;
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTotalesProductos: TFormTotalesProductos;

implementation

uses UnidadVariedades, UnidadFincas, UnidadProductos, UnidadMenuPrincipal,
  UnidadI;

{$R *.DFM}

procedure TFormTotalesProductos.BitBtn3Click(Sender: TObject);
begin
  close;
end;

procedure TFormTotalesProductos.BitBtn2Click(Sender: TObject);
begin
  if formmenuprincipal.VTProgreso=1 then
  begin
    formi.L.caption := 'Realizando clculos, espere por favor...';
    formi.B.visible := false;
    formi.show;
    formi.refresh;
  end;
  if txtplan.text = 'Plan de abonado' then
  begin
    c.close;
    c.SQL.Clear;
    c.sql.add('SELECT P.Nombre AS Producto, SUM(DosisPeriodo)  AS Cantidad, P.UnidadDosis AS Unidad');
    c.sql.add('FROM ProductosPlanAbonado AS ProductosP, PlanAbonado AS Planes,  Producto AS P');
    c.sql.add('WHERE ProductosP.PlanAbonado = Planes.ID AND');
    c.sql.add('(Planes.Fecha <= :FechaMax AND Planes.Fecha >= :FechaMin) AND');
    c.sql.add('P.ID = ProductosP.IDProducto AND Planes.Finca = :Finca');
    c.sql.add('GROUP BY P.Nombre, P.UnidadDosis');
    c.ParamByName('FechaMax').value := strtodate(txthasta.text);
    c.ParamByName('FechaMin').value := strtodate(txtdesde.text);
    c.ParamByName('Finca').value := txtfinca.keyvalue;
    c.ExecSQL;
    c.open;
  end;

  if txtplan.text = 'Plan de tratamiento' then
  begin
    c.close;
    c.SQL.Clear;
    c.sql.add('SELECT P.Nombre AS Producto, SUM(TotalProducto) AS Cantidad, P.UnidadDosis AS Unidad');
    c.sql.add('FROM ProductosPlanTratamiento AS Productos, PlanTratamiento AS Planes,  Producto AS P');
    c.sql.add('WHERE Productos.PlanTratamiento = Planes.ID AND');
    c.sql.add('(Planes.Fecha <= :FechaMax AND Planes.Fecha >= :FechaMin) AND');
    c.sql.add('P.ID = Productos.IDProducto AND Planes.Finca = :Finca');
    c.sql.add('GROUP BY P.Nombre, P.UnidadDosis');
    c.ParamByName('FechaMax').value := strtodate(txthasta.text);
    c.ParamByName('FechaMin').value := strtodate(txtdesde.text);
    c.ParamByName('Finca').value := txtfinca.keyvalue;
    c.ExecSQL;
    c.open;
  end;

  if formmenuprincipal.VTProgreso=1 then
    formi.close;
end;

procedure TFormTotalesProductos.FormShow(Sender: TObject);
begin
  txtdesde.text:=DateToStr(date-365);
  txthasta.text:=DateToStr(date);
  Tfinca.open;
end;

procedure TFormTotalesProductos.BitBtn1Click(Sender: TObject);
begin
  if txtplan.text = 'Plan de abonado' then
    limpresion.ReportTitle := 'LISTADO DE PRODUCTOS CONSUMIDOS EN PLANES DE ABONADOS'
  else
    limpresion.ReportTitle := 'LISTADO DE PRODUCTOS CONSUMIDOS EN PLANES DE TRATAMIENTOS';
  lfinca.Caption := txtfinca.text;
  lempresa.caption :=  formmenuprincipal.vtnombreempresa + ' [' + datetostr (formmenuprincipal.vtinicioempresa) +
        ' - ' + datetostr (formmenuprincipal.vtfinempresa) + ']';
  lperiodo.caption := 'Desde: ' + txtdesde.text + ' Hasta: ' + txthasta.text;
  LImpresion.Preview;
end;

end.
