unit UnidadVariedades;

interface

uses
  Windows, Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, Mask, DBTables, ExtCtrls, ComCtrls, Buttons, Grids,
  DBGrids, Menus, ToolWin, Qrctrls, QuickRpt, variants;

type
  TFormVariedades = class(TForm)
    DVariedades: TDataSource;
    TVariedades6: TTable;
    ScrollBox1: TScrollBox;
    Panel2: TPanel;
    Navegador: TDBNavigator;
    BAnadir: TBitBtn;
    BEliminar: TBitBtn;
    N: TStaticText;
    Panel3: TPanel;
    Tabla: TDBGrid;
    LImpresion: TQuickRep;
    QRSubDetail2: TQRSubDetail;
    QRDBText11: TQRDBText;
    QRDBText12: TQRDBText;
    QRDBText15: TQRDBText;
    GroupHeaderBand1: TQRBand;
    QRLabel11: TQRLabel;
    QRLabel13: TQRLabel;
    QRLabel14: TQRLabel;
    PageFooterBand1: TQRBand;
    QRSysData1: TQRSysData;
    QRSysData3: TQRSysData;
    LEmpresa: TQRLabel;
    PageHeaderBand1: TQRBand;
    LTitulo: TQRSysData;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    LBuscar: TLabel;
    TxtBuscar: TEdit;
    OpOrdenarNombre: TRadioButton;
    RadioButton2: TRadioButton;
    DBD: TDataSource;
    TTabla: TTable;
    PopupMenu1: TPopupMenu;
    Aadirnuevafinca1: TMenuItem;
    N1: TMenuItem;
    Previsualizar1: TMenuItem;
    N3: TMenuItem;
    Cerrarventana1: TMenuItem;
    procedure EditFloracionEnter(Sender: TObject);
    procedure EditRecoleccionEnter(Sender: TObject);
    procedure EditCaidaHojaEnter(Sender: TObject);
    procedure EditBroteEnter(Sender: TObject);
    procedure TVariedades6AfterScroll(DataSet: TDataSet);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TVariedades6PostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure BEliminarClick(Sender: TObject);
    procedure BAnadirClick2(Sender: TObject);
    procedure BEliminarClick2(Sender: TObject);
    procedure BitBtn1Click2(Sender: TObject);
    procedure BPrevisualizarClick(Sender: TObject);
    procedure OpOrdenarNombreClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure TTablaAfterInsert(DataSet: TDataSet);
    procedure TTablaAfterScroll(DataSet: TDataSet);
    procedure TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TTablaAfterPost(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormVariedades: TFormVariedades;

implementation

uses UnidadDatos, UnidadMenuPrincipal;

{$R *.DFM}

procedure TFormVariedades.EditFloracionEnter(Sender: TObject);
begin
  dvariedades.dataset.FieldByName('Floracion').editmask:='!99/99/00;1;_';
end;

procedure TFormVariedades.EditRecoleccionEnter(Sender: TObject);
begin
  dvariedades.dataset.FieldByName('Recoleccion').editmask:='!99/99/00;1;_';
end;

procedure TFormVariedades.EditCaidaHojaEnter(Sender: TObject);
begin
  dvariedades.dataset.FieldByName('CaidaHoja').editmask:='!99/99/00;1;_';
end;

procedure TFormVariedades.EditBroteEnter(Sender: TObject);
begin
  dvariedades.dataset.FieldByName('Brote').editmask:='!99/99/00;1;_';
end;

procedure TFormVariedades.TVariedades6AfterScroll(DataSet: TDataSet);
begin
     n.caption:='Variedad ' + inttostr(dvariedades.dataset.recno) + ' de ' + inttostr(dvariedades.DataSet.recordcount);
end;



procedure TFormVariedades.TVariedades6PostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('La variedad introducida ya existe, cmbiela y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtinformation,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;


procedure TFormVariedades.BEliminarClick(Sender: TObject);
var
  nombre: string;
begin
  if not (dvariedades.dataset.fieldbyname('Nombre').value=Null) then
    Nombre:=dvariedades.dataset.fieldbyname('Nombre').value
  else
    nombre:='';
  if datos.dvariedadesfinca.DataSet.Locate('IDVariedad',dvariedades.DataSet.fieldbyname('ID').value,[]) then
  begin
    messagedlg('La variedad [' + nombre + '] No se puede eliminar ya que est en fincas.',mterror,[mbok],0);
    exit;
  end;
  if messagedlg('Est seguro que desea ELIMINAR la variedad [' + nombre + ']? Proceda con precaucin, la variedad ser eliminada permanentemente y no podr recuperarla.',mtconfirmation,[mbno,mbyes],0)=mryes then
  begin
    dvariedades.dataset.delete;
    messagedlg ('La variedad ha sido eliminada correctamente.',mtinformation,[mbok],0)
  end;
end;

procedure TFormVariedades.BAnadirClick2(Sender: TObject);
begin
  dbd.dataset.Insert;
end;





procedure TFormVariedades.BEliminarClick2(Sender: TObject);
var
  nombre: string;
begin
  if dbd.DataSet.recordcount=0 then
    messagedlg('No hay variedades para eliminar.',mtinformation,[mbok],0)
  else
  begin
    if not (dbd.dataset.fieldbyname('Nombre').value=Null) then
      Nombre:=dbd.dataset.fieldbyname('Nombre').value
    else
      nombre:='';
    datos.tvariedadesfinca.open;
    if datos.tvariedadesfinca.Locate('IDVariedad',dbd.DataSet.fieldbyname('ID').value,[]) then
      messagedlg('La variedad [' + nombre + '] No se puede eliminar ya que existe en fincas.',mtinformation,[mbok],0)
    else
      if messagedlg('Est seguro que desea ELIMINAR la variedad [' + nombre + ']?',mtconfirmation,[mbno,mbyes],0)=mryes then
        dbd.dataset.delete;
  end;
end;

procedure TFormVariedades.BitBtn1Click2(Sender: TObject);
begin
  close;
end;

procedure TFormVariedades.BPrevisualizarClick(Sender: TObject);
begin
  lempresa.caption:=formmenuprincipal.vtnombreempresa;
  limpresion.ReportTitle:='LISTADO DE VARIEDADES';
  limpresion.Preview;
end;


procedure TFormVariedades.OpOrdenarNombreClick(Sender: TObject);
begin
  ttabla.indexfieldnames:='Nombre';
  lbuscar.caption:='Nombre a &buscar:';
end;

procedure TFormVariedades.RadioButton2Click(Sender: TObject);
begin
  ttabla.indexfieldnames:='ID';
  lbuscar.caption:='ID a &buscar:';
end;

procedure TFormVariedades.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if key='.' then
    if tabla.Columns[tabla.selectedindex].fieldname='Precio'then
      key:=',';
end;

procedure TFormVariedades.TTablaAfterInsert(DataSet: TDataSet);
begin
  tabla.setfocus;
  tabla.SelectedIndex:=1;  
end;

procedure TFormVariedades.TTablaAfterScroll(DataSet: TDataSet);
begin
  n.caption:=inttostr(dbd.dataset.recno) + ' de ' + inttostr(dbd.DataSet.recordcount);
end;



procedure TFormVariedades.TTablaPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
var
  i: integer;
begin
  if E is EDBEngineError then
  begin
    for i:=0 to EDBEngineError(E).errorcount-1 do
    begin
      if EDBEngineError(E).errors[i].Errorcode=9729 then
      begin
        messagedlg('La variedad introducida ya existe. Elimnela antes de continuar',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end
      else
      begin
        messagedlg('Hay algn dato incorrecto. Compruebe los datos y vuelva a intentarlo.',mtwarning,[mbok],0);
        action := daAbort;
        exit;
      end;
    end;
  end;
end;

procedure TFormVariedades.TxtBuscarChange(Sender: TObject);
begin
  try
    ttabla.findnearest([txtbuscar.text])
  except
  end;  
end;

procedure TFormVariedades.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (dbd.dataset.state=dsinsert) or (dbd.dataset.state=dsedit) then
    dbd.DataSet.post;
  action:=caFree;
  screen.cursor:=crdefault;  
end;

procedure TFormVariedades.FormShow(Sender: TObject);
begin
  opordenarnombreclick(sender);
  ttabla.open;
  n.caption:=inttostr(dbd.dataset.recno) + ' de ' + inttostr(dbd.DataSet.recordcount);
  if formmenuprincipal.VTMostrarBBVentanas=1 then
    cb.visible:=true
  else
    cb.visible:=false;
  if formmenuprincipal.vtflat=1 then
  begin
    navegador.flat:=true;
    bb.flat:=true;
  end
  else
  begin
    navegador.flat:=false;
    bb.flat:=false;
  end;
  screen.cursor:=crdefault;
end;

procedure TFormVariedades.TTablaAfterPost(DataSet: TDataSet);
begin
  ttabla.FlushBuffers;
end;

end.
